﻿/* Copyrights 2010 -2011 , Ashish Patil
 * http://ashishware.com
 * DISCLAIMER: The author is not responsible for any damage this program can cause to your system.
 * This program is only for educational purposes. This program has NOT been thoroughly tested.
 * Use it at your own RISK.
 * 
 * Please retain this notice in any derivative works or modified code. 
 *  
 * 
 * */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.IO;
using System.Timers;
using System.Net.NetworkInformation;
using System.Configuration;

namespace NWUsageMeter
{
    public partial class Form1 : Form
    {
        static PerformanceCounter dataSentCounter;
        static PerformanceCounter dataReceivedCounter;
        System.Timers.Timer  networkMonitor;
        string category, instance, fileName;
        static float u, d;

        public Form1()
        {
             InitializeComponent();
             category = ConfigurationSettings.AppSettings["Category"];
             instance = ConfigurationSettings.AppSettings["Instance"];
             fileName = ConfigurationSettings.AppSettings["FilePath"];
             dataSentCounter = new PerformanceCounter(category, "Bytes Transmitted", instance);
             dataReceivedCounter = new PerformanceCounter(category, "Bytes Received", instance);
             NetworkChange.NetworkAvailabilityChanged += new NetworkAvailabilityChangedEventHandler(NetworkChange_NetworkAvailabilityChanged);
             networkMonitor = new System.Timers.Timer();
             networkMonitor.Interval = Int32.Parse(ConfigurationSettings.AppSettings["NetworkPollInterval"]);
             networkMonitor.Elapsed += new ElapsedEventHandler(networkMonitor_Elapsed);         
        }

        void networkMonitor_Elapsed(object sender, ElapsedEventArgs e)
        {
            float temp_u=0, temp_d=0;
            try
            {   temp_u  = dataSentCounter.NextValue();
                temp_d = dataReceivedCounter.NextValue();

            }
            catch  
            {
                LogUsage();
                u = 0; d = 0;
                networkMonitor.Stop();
                return;
            }

            if (temp_u == 0f && temp_d == 0f)
            {
                LogUsage();
                networkMonitor.Stop();
                return;
            }
            u = temp_u; d = temp_d;          
        }

   
        void NetworkChange_NetworkAvailabilityChanged(object sender, NetworkAvailabilityEventArgs e)
        {
            if (e.IsAvailable)
            {networkMonitor.Start();}             
        }
       
        private void notifyIcon1_MouseMove(object sender, MouseEventArgs e)
        {
            notifyIcon1.Text = string.Format("{0}\nDn:{1} bytes, Ul:{2} bytes",instance,d,u);           
        }
        
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            LogUsage();
            dataSentCounter.Close();
            dataReceivedCounter.Close();                     
        }

        private void WriteUsageToFile()
        {
             if (!File.Exists(fileName))
                File.Create(fileName);

            string username = System.Environment.UserName;
            string logEntry = string.Format("{0},{1},{2},{3}\n", d, u, username, DateTime.Now.ToString());
            File.AppendAllText(fileName, logEntry);
        }

        private void LogUsage()
        {
            try
            {
                if(u > 0f || d > 0f) 
               WriteUsageToFile();
                u = 0; d = 0;
            }
            catch (Exception ex)
            {
                MessageBox.Show(this, ex.ToString());
                networkMonitor.Stop();
            }

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            try
            {
                u = dataSentCounter.NextValue();
                d = dataReceivedCounter.NextValue();
            }
            catch
            { return; }
            networkMonitor.Start();
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        { this.Close(); }

    }
}
